--Copyright 1986-2014 Xilinx, Inc. All Rights Reserved.
----------------------------------------------------------------------------------
--Tool Version: Vivado v.2014.4 (win64) Build 1071353 Tue Nov 18 18:24:04 MST 2014
--Date        : Tue Jun 23 15:29:57 2015
--Host        : FRANKFURT running 64-bit Service Pack 1  (build 7601)
--Command     : generate_target mars_zx3_wrapper.bd
--Design      : mars_zx3_wrapper
--Purpose     : IP block netlist
----------------------------------------------------------------------------------


library ieee;
	use ieee.std_logic_1164.all;
	use ieee.numeric_std.all;

library unisim;
	use unisim.vcomponents.all;
	
entity mars_zx3_wrapper is
  port (
          DDR_addr            : inout std_logic_vector ( 14 downto 0 );
          DDR_ba                : inout std_logic_vector ( 2 downto 0 );
          DDR_cas_n            : inout std_logic;
          DDR_ck_n            : inout std_logic;
          DDR_ck_p            : inout std_logic;
          DDR_cke                : inout std_logic;
          DDR_cs_n            : inout std_logic;
          DDR_dm                : inout std_logic_vector ( 3 downto 0 );
          DDR_dq                : inout std_logic_vector ( 31 downto 0 );
          DDR_dqs_n            : inout std_logic_vector ( 3 downto 0 );
          DDR_dqs_p            : inout std_logic_vector ( 3 downto 0 );
          DDR_odt                : inout std_logic;
          DDR_ras_n            : inout std_logic;
          DDR_reset_n            : inout std_logic;
          DDR_we_n            : inout std_logic;
          
          FIXED_IO_ddr_vrn    : inout std_logic;
          FIXED_IO_ddr_vrp    : inout std_logic;
          FIXED_IO_mio        : inout std_logic_vector ( 53 downto 0 );
          FIXED_IO_ps_clk     : inout std_logic;
          FIXED_IO_ps_porb    : inout std_logic;
          FIXED_IO_ps_srstb   : inout std_logic;
  
          Eth_Rst_N           : inout    std_logic;
          Usb_Rst_N           : inout    std_logic;
  
          UART0_TX            : out     std_logic; 
          UART0_RX            : in     std_logic;
  
          I2C0_SDA            : inout std_logic; 
          I2C0_SCL            : inout std_logic; 
          I2C0_INT_N            : in     std_logic; 
  
          Led_N                 : out    std_logic_vector(3 downto 0);
          
          -- unused pins, set to high impedance
          Vref0               : inout std_logic; 
          Vref1               : inout std_logic; 
          CLK33               : inout std_logic;
          NAND_WP             : inout std_logic;
          PWR_GOOD_R          : inout std_logic;
          DDR3_VSEL           : inout std_logic;
          ETH_Link            : inout std_logic;
          ETH_MDC             : inout std_logic; 
          ETH_MDIO            : inout std_logic; 
          ETH_RX_CLK          : inout std_logic; 
          ETH_RX_CTL          : inout std_logic; 
          ETH_RXD             : inout std_logic_vector(3 downto 0);
          ETH_TX_CLK          : inout std_logic; 
          ETH_TX_CTL          : inout std_logic; 
          ETH_TXD             : inout std_logic_vector(3 downto 0);
          MIO40               : inout std_logic;
          MIO41               : inout std_logic;
          MIO42               : inout std_logic;
          MIO43               : inout std_logic;
          MIO44               : inout std_logic;
          MIO45               : inout std_logic;
  --        MIO46               : inout std_logic;
  --        MIO47               : inout std_logic;
          MIO48               : inout std_logic;
          MIO49               : inout std_logic;
          MIO50               : inout std_logic;
          MIO51               : inout std_logic
      );
end mars_zx3_wrapper;

architecture STRUCTURE of mars_zx3_wrapper is
  component mars_zx3_pm3 is
  port (
    FCLK_CLK1 : out STD_LOGIC;
    RESET_N : out STD_LOGIC;
    DDR_cas_n : inout STD_LOGIC;
    DDR_cke : inout STD_LOGIC;
    DDR_ck_n : inout STD_LOGIC;
    DDR_ck_p : inout STD_LOGIC;
    DDR_cs_n : inout STD_LOGIC;
    DDR_reset_n : inout STD_LOGIC;
    DDR_odt : inout STD_LOGIC;
    DDR_ras_n : inout STD_LOGIC;
    DDR_we_n : inout STD_LOGIC;
    DDR_ba : inout STD_LOGIC_VECTOR ( 2 downto 0 );
    DDR_addr : inout STD_LOGIC_VECTOR ( 14 downto 0 );
    DDR_dm : inout STD_LOGIC_VECTOR ( 3 downto 0 );
    DDR_dq : inout STD_LOGIC_VECTOR ( 31 downto 0 );
    DDR_dqs_n : inout STD_LOGIC_VECTOR ( 3 downto 0 );
    DDR_dqs_p : inout STD_LOGIC_VECTOR ( 3 downto 0 );
    FIXED_IO_mio : inout STD_LOGIC_VECTOR ( 53 downto 0 );
    FIXED_IO_ddr_vrn : inout STD_LOGIC;
    FIXED_IO_ddr_vrp : inout STD_LOGIC;
    FIXED_IO_ps_srstb : inout STD_LOGIC;
    FIXED_IO_ps_clk : inout STD_LOGIC;
    FIXED_IO_ps_porb : inout STD_LOGIC;
    IIC_0_sda_i : in STD_LOGIC;
    IIC_0_sda_o : out STD_LOGIC;
    IIC_0_sda_t : out STD_LOGIC;
    IIC_0_scl_i : in STD_LOGIC;
    IIC_0_scl_o : out STD_LOGIC;
    IIC_0_scl_t : out STD_LOGIC;
    UART_1_txd : out STD_LOGIC;
    UART_1_rxd : in STD_LOGIC
  );
  end component mars_zx3_pm3;
 
  signal iic_0_scl_i : STD_LOGIC;
  signal iic_0_scl_o : STD_LOGIC;
  signal iic_0_scl_t : STD_LOGIC;
  signal iic_0_sda_i : STD_LOGIC;
  signal iic_0_sda_o : STD_LOGIC;
  signal iic_0_sda_t : STD_LOGIC;
  
  signal Clk				: std_logic;
  signal Rst                : std_logic := '0';
  signal Rst_N             : std_logic := '1';
  signal ETH_RST            : std_logic := '0';
      
  signal RstCnt            : unsigned (15 downto 0) := (others => '0'); -- 1ms reset for Ethernet PHY
      
  signal LedCount            : unsigned (23 downto 0);
  --    signal GPIO                : std_logic_vector (7 downto 0);
begin

mars_zx3_pm3_i: component mars_zx3_pm3
    port map (
      DDR_addr(14 downto 0) => DDR_addr(14 downto 0),
      DDR_ba(2 downto 0) => DDR_ba(2 downto 0),
      DDR_cas_n => DDR_cas_n,
      DDR_ck_n => DDR_ck_n,
      DDR_ck_p => DDR_ck_p,
      DDR_cke => DDR_cke,
      DDR_cs_n => DDR_cs_n,
      DDR_dm(3 downto 0) => DDR_dm(3 downto 0),
      DDR_dq(31 downto 0) => DDR_dq(31 downto 0),
      DDR_dqs_n(3 downto 0) => DDR_dqs_n(3 downto 0),
      DDR_dqs_p(3 downto 0) => DDR_dqs_p(3 downto 0),
      DDR_odt => DDR_odt,
      DDR_ras_n => DDR_ras_n,
      DDR_reset_n => DDR_reset_n,
      DDR_we_n => DDR_we_n,
      FCLK_CLK1 => Clk,
      FIXED_IO_ddr_vrn => FIXED_IO_ddr_vrn,
      FIXED_IO_ddr_vrp => FIXED_IO_ddr_vrp,
      FIXED_IO_mio(53 downto 0) => FIXED_IO_mio(53 downto 0),
      FIXED_IO_ps_clk => FIXED_IO_ps_clk,
      FIXED_IO_ps_porb => FIXED_IO_ps_porb,
      FIXED_IO_ps_srstb => FIXED_IO_ps_srstb,
      IIC_0_scl_i => iic_0_scl_i,
      IIC_0_scl_o => iic_0_scl_o,
      IIC_0_scl_t => iic_0_scl_t,
      IIC_0_sda_i => iic_0_sda_i,
      IIC_0_sda_o => iic_0_sda_o,
      IIC_0_sda_t => iic_0_sda_t,
      RESET_N => Rst_N,
      UART_1_rxd => UART0_RX,
      UART_1_txd => UART0_TX
    );
    
    
        -- supply voltage for thh DDR3 memory
        DDR3_VSEL       <= '0'; -- 1.35V
    --  DDR3_VSEL       <= 'Z'; -- 1.5V
    
        -- tristate buffer
        I2C0_SDA    <= IIC_0_sda_o when IIC_0_sda_t = '0' else 'Z';
        IIC_0_sda_i <= I2C0_SDA;
        I2C0_SCL    <= IIC_0_scl_o when IIC_0_scl_t = '0' else 'Z';
        IIC_0_scl_i <= I2C0_SCL;
    
        ------------------------------------------------------------------------------------------------
        --    Clock and Reset
        ------------------------------------------------------------------------------------------------ 
           
        --  reset 1ms reset for Ethernet PHY
           process (Clk)
           begin
            if rising_edge (Clk) then
                   if (not RstCnt) = 0 then
                       Rst            <= '0';
                   else
                       Rst            <= '1';
                       RstCnt        <= RstCnt + 1;
                   end if;
               end if;
           end process;
    
        ETH_RST_N <= '0' when Rst = '1' else 'Z';
        USB_RST_N <= '0' when Rst = '1' else 'Z';
        
        ------------------------------------------------------------------------------------------------
        -- Blinking LED counter
        ------------------------------------------------------------------------------------------------
       
        process (Clk)
        begin
            if rising_edge (Clk) then
                if Rst = '1' then
                    LedCount    <= (others => '0');
                else
                    LedCount <= LedCount + 1;
                end if;
            end if;
        end process;
        
        
        Led_N(3) <= not LedCount(23);
        Led_N(2) <= '1'; -- not GPIO(2);
        Led_N(1) <= '1'; -- not GPIO(1);
        Led_N(0) <= '1'; -- not GPIO(0);
    
    
        ------------------------------------------------------------------------------------------------
        -- Unused pins
        ------------------------------------------------------------------------------------------------
    
         -- system pins, set to high impedance if not used
        Vref0             <= 'Z';
        Vref1             <= 'Z';
        CLK33            <= 'Z';
        NAND_WP            <= 'Z';
        PWR_GOOD_R        <= 'Z';
        
        -- shared mio pins, set to high impedance if not used
        MIO40            <= 'Z'; 
        MIO41            <= 'Z'; 
        MIO42            <= 'Z'; 
        MIO43            <= 'Z'; 
        MIO44            <= 'Z'; 
        MIO45            <= 'Z'; 
    --    MIO46            <= 'Z';  -- used for uart on Mars EB1
    --    MIO47            <= 'Z';  -- used for uart on Mars EB1
        MIO48            <= 'Z'; 
        MIO49            <= 'Z'; 
        MIO50            <= 'Z'; 
        MIO51            <= 'Z';     
        ETH_Link        <= 'Z';    
        ETH_MDC            <= 'Z';
        ETH_MDIO        <= 'Z'; 
        ETH_RX_CLK        <= 'Z'; 
        ETH_RX_CTL        <= 'Z'; 
        ETH_RXD            <= (others => 'Z'); 
        ETH_TX_CLK        <= 'Z'; 
        ETH_TX_CTL        <= 'Z'; 
        ETH_TXD            <= (others => 'Z'); 
    
end STRUCTURE;
